

module My
  class Combination

    attr_reader :index, :length

    # 范围包含 start，不包含 stop
    def initialize arrays, start: 0, stop: nil
      @arrays = arrays
      @length = arrays.reduce(1){|n, a| a.size * n }
      @start = start
      @index = start
      @stop = stop || length
      @stop = length if @stop > length
      raise IndexError if @stop <= @start
    end

    def values
      i = @index
      @arrays.map do |array|
        i, n = i.divmod(array.size)
        array[n]
      end
    end

    def succ!
      raise StopIteration unless succ?
      @index += 1
      nil
    end

    def succ?
      @index < @stop - 1
    end

    def diff_count
      @index - @start
    end

  end
end
