
# 分割连续的子序列
module My
  class SplitSequence

    def split(seq)
      result = []
      return result if seq.length == 0
      group = new_group
      group << seq[0]
      1.upto(seq.length - 1) do |i|
        unless succ?(group[group.length - 1], seq[i])
          result << group
          group = new_group
        end
        group << seq[i]
      end
      result << group
      result
    end

    # 创建新的分组
    def new_group
      raise NotImplementedError
    end

    # 判断两个成员是否连续
    def succ?(a, b)
      raise NotImplementedError
    end

  end
end
