
module My

  module Unicode

    module_function

    # decode('\u4EA6\u53EF\u8D5B\u8247')
    # => '亦可赛艇'
    def decode(str)
      str.gsub(/\\u([0-9a-fA-F]{4})/){ [$1.to_i(16)].pack('U') }
    end

    # decode_bytes('\xE9\x92\xA6\xE5\xAE\x9A')
    # => '钦定'
    def decode_bytes(str)
      str.gsub(/\\x([0-9a-fA-F]{2})/){ $1.to_i(16).chr }.force_encoding("utf-8")
    end

    # encode('亦可赛艇')
    # => ‘\u4EA6\u53EF\u8D5B\u8247’
    def encode(str)
      str.each_codepoint.reduce(''){|s, cp| s << '\\u%04X' % cp }
    end

    # encode_bytes('钦定')
    # => '\xE9\x92\xA6\xE5\xAE\x9A'
    def encode_bytes(str)
      str.each_byte.reduce(''){|s, b| s << '\x%02X' % b }
    end

  end

end
